sys_get_args:
  pushad
    mov esi,0x81
    mov edi,sys_argv
    mov cl,[0x80]




   .while_ln28:
   cmp cl,0
   jz .while_ln28_end
       cmp byte[esi],0x20
       je .not_if_ln28
       cmp byte[esi],0x0D
       je .not_if_ln28

       inc dword[sys_argc]

       mov dword[edi],esi
       add edi,4


       call sys_args_last_arg_char

       mov dword[edi],eax
       sub dword[edi],esi
       sub cl,[edi]

        mov esi,eax
        add edi,4

       jmp .while_ln28

     .not_if_ln28:

   ;//These 2 instructions are only in case
   ;//the characters are 0x20 or 0x0D, and the
   ;//"continue" just above avoids it from being
   ;//run if we processed actual characters in this
   ;//iteration:
   ;;
    inc esi
    dec cl

   jmp .while_ln28
   .while_ln28_end:

  popad
ret



align 16
db "int argc void *argv             "
 sys_argc dd 0
 sys_argv times 128 dd 0

align 16
db "       int argc void *argv {END}"



sys_args_last_arg_char:
  push ecx
    mov eax,esi

   .while_ln74:
   cmp cl,0
   jz .while_ln74_end
      cmp byte[eax],0x20
      je .while_ln74_end
      cmp byte[eax],0x0D
      je .while_ln74_end


      inc eax
      dec cl

   jmp .while_ln74
   .while_ln74_end:

  pop ecx
ret
